<?php

namespace FiloBlu\OrderAdditionalData\Block\Adminhtml\System\Config;

use Magento\Config\Block\System\Config\Form\Field\FieldArray\AbstractFieldArray;
use Magento\Framework\Exception\LocalizedException;
use Magento\Framework\View\Element\Html\Select;

/**
 * Class OrderDataFields
 * @package FiloBlu\OrderAdditionalData\Block\Adminhtml\System\Config
 */
class OrderDataFields extends AbstractFieldArray
{
    /**
     * Enable the "Add after" button or not
     *
     * @var bool
     */
    protected $_addAfter = true;

    /**
     * Rows cache
     *
     * @var array|null
     */
    private $_arrayRowsCache;

    /**
     * Prepare to render
     *
     * @return void
     * @throws LocalizedException
     */
    protected function _prepareToRender()
    {
        $this->addColumn('fieldname', [
            'label' => __('Order Field Name')
        ]);

        $selectBlock = $this->getLayout()->createBlock(Select::class)
            ->setId($this->_getCellInputElementId('<%- _id %>', 'object_type'))
            ->setName($this->_getCellInputElementName('object_type'))
            ->setClass('select')
            ->setOptions(
                [
                    ['value' => '', 'label' => __('-- Please Select --')],
                    ['value' => 'customer', 'label' => __('Customer')],
                    ['value' => 'billing_address', 'label' => __('Billing Address')],
                    ['value' => 'shipping_address', 'label' => __('Shipping Address')],
                    ['value' => 'order', 'label' => __('Order')],
                    ['value' => 'free_shipping', 'label' => __('Free Shipping')]
                ]
            );
        $this->addColumn('object_type', [
            'label'    => __('Object Type'),
            'renderer' => $selectBlock
        ]);

        $this->addColumn('object_field', [
            'label' => __('Object Field Code')
        ]);

        $this->_addAfter = false;
        $this->_addButtonLabel = __('Add');
    }
}
